java-jee-tomcat/src/main/java/com/github/marcopollivier/model/Departamento.java
package com.github.marcopollivier.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;

@Entity
public class Departamento implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue
	private Integer id;
	
	private String name;
	
	@OneToMany(mappedBy="departamento", cascade=CascadeType.PERSIST)
	private List<Empregado> empregados;
	
	public Departamento() {
		super();
		empregados = new ArrayList<>();
	}
	
	public Departamento(String name) {
		this();
		this.setName(name);
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	public List<Empregado> getEmpregados() {
		return empregados;
	}
	
	public void setEmpregados(List<Empregado> empregados) {
		this.empregados = empregados;
	}
	
}

java-jee-tomcat/src/main/java/com/github/marcopollivier/model/Empregado.java
package com.github.marcopollivier.model;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.validation.constraints.NotNull;

@Entity
public class Empregado implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue
	private Integer id;
	
	private String name;
	
	@ManyToOne(fetch=FetchType.EAGER)
	@NotNull
	private Departamento departamento;
	
	public Empregado() {
		super();
	}
	
	public Empregado(String name) {
		this();
		this.setName(name);
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	public Departamento getDepartamento() {
		return departamento;
	}
	
	public void setDepartamento(Departamento departamento) {
		this.departamento = departamento;
	}
	
}

java-jee-tomcat/src/main/java/com/github/marcopollivier/controller/DepartamentoController.java
package com.github.marcopollivier.controller;

import java.util.List;

import com.github.marcopollivier.model.Departamento;

public interface DepartamentoController {

	public Departamento create(Departamento dpto);
	public Departamento update(Departamento dpto);
	public Departamento retrieve(Integer id);
	public List<Departamento> retrieve();
	public void delete(Departamento dpto);
	
}

java-jee-tomcat/src/main/java/com/github/marcopollivier/controller/EmpregadoController.java
package com.github.marcopollivier.controller;

import java.util.List;

import com.github.marcopollivier.model.Empregado;

public interface EmpregadoController {

	public Empregado create(Empregado emp);
	public Empregado update(Empregado emp);
	public Empregado retrieve(Integer id);
	public List<Empregado> retrieve();
	public void delete(Empregado emp);
	
}

java-jee-tomcat/src/main/java/com/github/marcopollivier/view/DepartamentoMB.java
package com.github.marcopollivier.view;

import java.io.IOException;
import java.io.Serializable;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.inject.Named;

import org.primefaces.event.RowEditEvent;

import com.github.marcopollivier.controller.DepartamentoController;
import com.github.marcopollivier.controller.impl.DepartamentoControllerImpl;
import com.github.marcopollivier.model.Departamento;

@RequestScoped
@Named(value="departamentoMB")
public class DepartamentoMB implements Serializable{

	private static final long serialVersionUID = 1L;

	private Departamento entity;
	private DepartamentoController controller;
	
	@PostConstruct
	public void init() {
		entity = new Departamento();
		controller = new DepartamentoControllerImpl();
	}
	
    public List<Departamento> getDepartamentos() {
    	return controller.retrieve();
    }
	
    public void saveButton(ActionEvent actionEvent) throws IOException {
        controller.create(entity);
    	addMessage("Departamento " + entity.getName() + " adicionado com sucesso");
    	
    	FacesContext.getCurrentInstance().getExternalContext().redirect("index.jsf");
    }
    
    public void deleteButton(ActionEvent actionEvent) throws IOException {
    	controller.delete(null);
    	addMessage("Departamento " + entity.getName() + " excluído com sucesso");
    	
    	FacesContext.getCurrentInstance().getExternalContext().redirect("index.jsf");
    }
    
    public void onRowEdit(RowEditEvent event) {
    	entity = controller.update((Departamento)event.getObject());
    	addMessage("Departamento Editado");
    }
     

    
    public void onRowCancel(RowEditEvent event) {
		addMessage("Alteração cancelada");
    }
	
    public void addMessage(String summary) {
        FacesMessage message = new FacesMessage(FacesMessage.SEVERITY_INFO, summary,  null);
        FacesContext.getCurrentInstance().addMessage(null, message);
    }
	
    //GETs and SETs
    public Departamento getEntity() {
		return entity;
	}
	
	public void setEntity(Departamento entity) {
		this.entity = entity;
	}
	
}


java-jee-tomcat/src/main/java/com/github/marcopollivier/view/EmpregadoMB.java
package com.github.marcopollivier.view;

import java.io.IOException;
import java.io.Serializable;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.inject.Named;

import org.primefaces.event.RowEditEvent;

import com.github.marcopollivier.controller.DepartamentoController;
import com.github.marcopollivier.controller.EmpregadoController;
import com.github.marcopollivier.controller.impl.DepartamentoControllerImpl;
import com.github.marcopollivier.controller.impl.EmpregadoControllerImpl;
import com.github.marcopollivier.model.Departamento;
import com.github.marcopollivier.model.Empregado;

@RequestScoped
@Named(value="empregadoMB")
public class EmpregadoMB implements Serializable{

	private static final long serialVersionUID = 1L;

	private Empregado entity;
	private EmpregadoController controller;
	private DepartamentoController depController;
	
	@PostConstruct
	public void init() {
		entity = new Empregado();
		controller = new EmpregadoControllerImpl();
		depController = new DepartamentoControllerImpl();
	}
	
    public List<Empregado> getEmpregados() {
    	return controller.retrieve();
    }
    
    public List<Departamento> getDepartamentos() {
    	return depController.retrieve();
    }
	
    public void saveButton(ActionEvent actionEvent) throws IOException {
        controller.create(entity);
    	addMessage("Empregado " + entity.getName() + " adicionado com sucesso");
    	FacesContext.getCurrentInstance().getExternalContext().redirect("index.jsf");
    }
    
    public void onRowEdit(RowEditEvent event) {
    	entity = controller.update((Empregado)event.getObject());
    	addMessage("Empregado Editado");
    }
     
    public void onRowCancel(RowEditEvent event) {
		addMessage("Edição cancelada");
    }
	
    public void addMessage(String summary) {
        FacesMessage message = new FacesMessage(FacesMessage.SEVERITY_INFO, summary,  null);
        FacesContext.getCurrentInstance().addMessage(null, message);
    }
	
    //GETs and SETs
    public Empregado getEntity() {
		return entity;
	}
	
	public void setEntity(Empregado entity) {
		this.entity = entity;
	}
	
}

java-jee-tomcat/src/main/java/com/github/marcopollivier/view/about/SystemInformationMB.java
package com.github.marcopollivier.view.about;

import java.io.Serializable;
import java.util.Date;

import javax.enterprise.context.RequestScoped;
import javax.inject.Named;

@RequestScoped
@Named(value="about")
public class SystemInformationMB implements Serializable {
	private static final long serialVersionUID = 1L;

	public String getName() {
		return "Marco Paulo Ollivier - " + new Date();
	}


}

java-jee-tomcat/src/main/webapp/add_departamento.xhtml
<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3c.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:p="http://primefaces.org/ui"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:ui="http://java.sun.com/jsf/facelets">
	
<h:head>
</h:head>
<h:body>
	
	<h1>Adicionar Departamento</h1>
	
	<h:form>
    	<p:growl id="growl" life="2000" />

		<p:outputLabel value="Nome:" for="txt-name" />
		<p:inputText id="txt-name" value="#{departamentoMB.entity.name}" />
		
		<br />
     
    	<p:commandButton value="Adicionar" id="add-departamento" update="growl" 
    					 actionListener="#{departamentoMB.saveButton}" 
    					 styleClass="ui-priority-primary" ajax="true" />
    					 
    	<p:commandButton action="index" value="Voltar" />
    					 
	</h:form>
</h:body>
</html>

java-jee-tomcat/src/main/webapp/add_empregado.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3c.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:p="http://primefaces.org/ui"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:ui="http://java.sun.com/jsf/facelets">
	
<h:head>
</h:head>
<h:body>
	
	<h1>Adicionar Empregado</h1>
	
	<h:form>
    	<p:growl id="growl" life="2000" />

		<p:outputLabel value="Departamento:" for="dd" />
        <p:autoComplete id="dd" dropdown="true" value="#{empregadoMB.entity.departamento}" completeMethod="#{empregadoMB.departamentos}"
                        var="departamento" itemLabel="#{departamento.name}" itemValue="#{departamento}" converter="departamentoConverter" forceSelection="true" />


		<br/>

		<p:outputLabel value="Nome:" for="txt-name" />
		<p:inputText id="txt-name" value="#{empregadoMB.entity.name}" />
		
		<br/>
     
    	<p:commandButton value="Adicionar" id="add-empregado" update="growl" 
    					 actionListener="#{empregadoMB.saveButton}" 
    					 styleClass="ui-priority-primary" ajax="true" />
    					 
    	<p:commandButton action="index" value="Voltar" />
    	
	</h:form>
</h:body>
</html>

java-jee-tomcat/src/main/webapp/index.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3c.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:p="http://primefaces.org/ui"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:ui="http://java.sun.com/jsf/facelets">
<h:head>
</h:head>
<h:body>
	<a href="add_departamento.jsf">Add Departamento</a>

	<h:form id="form">
		<p:growl id="msgs" life="2000"/>

		<p:dataTable id="dt-dpto" var="dpto" value="#{departamentoMB.departamentos}" editable="true" style="margin-bottom:20px">
			<f:facet name="header">Departamento</f:facet>

			<p:ajax event="rowEdit" listener="#{departamentoMB.onRowEdit}" update=":form:msgs" />
			<p:ajax event="rowEditCancel" listener="#{departamentoMB.onRowCancel}" update=":form:msgs" />

			<p:column headerText="Id" style="width:45px">
				<h:outputText value="#{dpto.id}" />
			</p:column>

			<p:column headerText="Nome">
				<p:cellEditor>
					<f:facet name="output">
						<h:outputText value="#{dpto.name}" />
					</f:facet>
					<f:facet name="input">
						<p:inputText value="#{dpto.name}" style="width:100%" label="Nome" />
					</f:facet>
				</p:cellEditor>
			</p:column>

			<p:column headerText="Editar" style="width:45px">
				<p:rowEditor />
			</p:column>
		</p:dataTable>

		<!--  -->
		<a href="add_empregado.jsf">Add Empregado</a>
		<p:dataTable id="dt-emp" var="emp" value="#{empregadoMB.empregados}" editable="true" style="margin-bottom:20px">
			<f:facet name="header">Empregado</f:facet>

			<p:ajax event="rowEdit" listener="#{empregadoMB.onRowEdit}" update=":form:msgs" />
			<p:ajax event="rowEditCancel" listener="#{empregadoMB.onRowCancel}" update=":form:msgs" />

			<p:column headerText="Id" style="width:45px">
				<h:outputText value="#{emp.id}" />
			</p:column>

			<p:column headerText="Nome">
				<p:cellEditor>
					<f:facet name="output">
						<h:outputText value="#{emp.name}" />
					</f:facet>
					<f:facet name="input">
						<p:inputText value="#{emp.name}" style="width:100%" label="Nome" />
					</f:facet>
				</p:cellEditor>
			</p:column>
			
	       <p:column headerText="Departamento">
	           <p:cellEditor>
	               <f:facet name="output"><h:outputText value="#{emp.departamento.name}" /></f:facet>
	               <f:facet name="input">
	                   <h:selectOneMenu value="#{emp.departamento.name}" style="width:100%">
	                       <f:selectItems value="#{empregadoMB.departamentos}" var="man" itemLabel="#{man}" itemValue="#{man}" />
	                   </h:selectOneMenu>
	               </f:facet>
	           </p:cellEditor>
	       </p:column>

			<p:column headerText="Editar" style="width:45px">
				<p:rowEditor />
			</p:column>
		</p:dataTable>


	</h:form>

	${about.name}

</h:body>
</html>